<html>
  <head>
    <title>Galileo board control panel</title>
    <link rel='stylesheet' href='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/webcontrols.css'/>
    <script type='text/javascript' src='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/webcontrols.js'></script>
    <script type='text/javascript' src='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/Measure.js'></script>
  </head>
  <body>
    <h1>Galileo board control panel</h1>
    <div class='button-bar'>
      <button onclick='doButton(this)' class='button' id='start' style='background-color:lightgreen'>Start</button>
      <button onclick='doButton(this)' class='button' style='background-color:yellow'>Run</button>
      <button onclick='doButton(this)' class='button' style='background-color:magenta'>Get</button> 
      <button onclick='doButton(this)' class='button' id='stop' style='background-color:red'>Stop</button>
      <button onclick='switchMode()' class='button' id='mode' style='background-color:gray'>Run mode</button>
    </div>
    <script>
      webcontrols.addConsole(true);
      var measures = [new Measure("1 "), new Measure("2 "), new Measure("3 "), new Measure("4 ")];
      function doButton(button) {
        let action = button.textContent.toLowerCase();
        if (action == "start") {
          for(i = 0; i < measures.length; i++)
            measures[i].clear();
          if(webcontrols.verbose == false)
            webcontrols.consoleClear();
        }
        webcontrols.curl("@/galileo", "action=" + action, "POST", function(answer) {
          if(webcontrols.verbose == false && action == "get") {
            webcontrols.consoleClear();
            try {
              let value = JSON.parse(answer);
              for(i = 0; i < measures.length; i++) {
                measures[i].add(value["detected_times"][i]);
                document.getElementById("console").innerHTML += "<ul><li>" + measures[i].asString(3) + "</li></ul>";
              }
            } catch(error) {
              webcontrols.consoleLog(answer);
            }
          }
        });
      }
      function switchMode(to_simple) {
        to_simple = to_simple == undefined ? document.getElementById("mode").innerText != "Test mode" : to_simple;
        if (to_simple) {
          document.getElementById("mode").innerText = "Test mode";
          document.getElementById("stop").style.visibility = "hidden";
          webcontrols.verbose = false;
        } else {
          document.getElementById("mode").innerText = "Run mode";
          document.getElementById("stop").style.visibility = "visible";
          webcontrols.verbose = true;
       }
      }
      switchMode(true);
    </script>
  </body>
</html>
